
.586p
.model flat
option scoped



include rasm.inc





ut_shade_bits equ 6

.data

extern _cur_end_span : dword
extern _cur_span     : dword





align 4

make_magic shade_r_magic ,52-32-5
make_magic tex_u_magic   ,52-32+8

tex_v_magic_alt  dd ?
tex_v_magic_alt_tp  dd ?

cur_span dd ?
cur_end_span dd ? 
public C cur_end_span,cur_span;






last_y   dd ? 
cur_poly dd ? 

int_duv   dd ? 
int_dvsh  dd ? 




cur_tmap_id_alt_sb     dd ?; 
cur_tmap_id_alt_tp_sb  dd ?; 



tmap_low_masks   db 0,1,3,7,15,31,63,127,255
tmap_high_masks  db 0,010000000b,011000000b,011100000b,011110000b
				 db 011111000b,011111100b,011111110b,011111111b


public C tmap_low_masks,tmap_high_masks


;align 4

;tmap_masks dd ((1 shl  0)-1),((1 shl  1)-1),((1 shl  2)-1),((1 shl  3)-1)
;		    dd ((1 shl  4)-1),((1 shl  5)-1),((1 shl  6)-1),((1 shl  7)-1)
;           dd ((1 shl  8)-1),((1 shl  9)-1),((1 shl 10)-1),((1 shl 11)-1)
;           dd ((1 shl 12)-1),((1 shl 13)-1),((1 shl 14)-1),((1 shl 15)-1)
;		    dd ((1 shl 16)-1)







.code

draw_sb_asm_start_0:
public C draw_sb_asm_start_0;








sb_poly	struct

  next dword ?
  prev dword ?

  z0  dword ?;
  dz0 dword ?;
  dz1 dword ?;

  _cur_span dword ?;

  tmap dword ?;  also color
 
  sh0 dword ?;
  dsh0 dword ?;
  dsh1 dword ?;

  u0 dword ?;
  du0 dword ?;
  du1 dword ?;

  v0 dword ?;
  dv0 dword ?;
  dv1 dword ?;

  span_buf dword ?;


sb_poly ends





rend_dat_tex	struct

  z0  dword ?;
  dz0 dword ?;
  dz1 dword ?;

  span_buf dword ?;

  tmap dword ?;  also color
 
  sh0 dword ?;
  dsh0 dword ?;
  dsh1 dword ?;

  u0 dword ?;
  du0 dword ?;
  du1 dword ?;

  v0 dword ?;
  dv0 dword ?;
  dv1 dword ?;


rend_dat_tex ends







@sb_fill_alt@8 proc public

   ;  there might be an agi with ecx here

    mov  eax, [ ecx ] .rend_dat_tex.span_buf  
	mov [_cur_end_span], edx;
    
	add  eax, 4;
    push esi

	push ebp
    push edi

    push ebx
 	mov edi, [ eax ];  get y point 

    shr edi, 20     ; extract y
    mov  [_esp_save], esp;
 
    mov [last_y],edi;
   	mov esi, [ecx].rend_dat_tex.tmap;

	mov ebx, [esi].texture.id;


	cmp [cur_tmap_id_alt_sb], ebx;
	je SAME_TEX;

	mov [cur_tmap_id_alt_sb], ebx;
 	
    mov ebx, [esi ].texture.clut
    mov dword ptr [__clut0-4], ebx;

	mov ebx, [esi].texture.map;	 get map part

	; these are all probably misaligned writes..
	mov dword ptr [TMAP_0-4], ebx;

	mov ebx, dword ptr [esi].texture.dim0;
	xor edx, edx;

	mov byte ptr [ ROL_BITS_0 - 1], bl
	
	mov dl,bh;
	and ebx,0000000ffh; 
	
	mov bl, tmap_high_masks[ebx]
	mov bh, tmap_low_masks[edx]

	ror ebx, 8;

	mov dword ptr [MASK_0-4], ebx;
	mov dword ptr [MASK_1-4], ebx;


	neg dl;
	add dl,127 + 52 - 32;

	shl edx, 23;

    or  edx, (1 shl 22 );

	mov [tex_v_magic_alt] , edx;


    SAME_TEX:

	mov esi, [ ecx ] .rend_dat_tex.sh0;
	mov ebx, [ ecx ] .rend_dat_tex.dsh0;

	mov edx, [ ecx ] .rend_dat_tex.dsh1;
	add esi, (SHADE_BIT_SCALE+8+8) shl 23;

	; scale all shade values
	mov [ ecx ] .rend_dat_tex.sh0,esi;
	add ebx, (SHADE_BIT_SCALE+8+8) shl 23;

	mov [ ecx ] .rend_dat_tex.dsh0,ebx;
	add edx, (SHADE_BIT_SCALE+8+8) shl 23;

	mov [ ecx ] .rend_dat_tex.dsh1,edx;



    fld   dword ptr [ ecx ] .rend_dat_tex.sh0;
    fadd  dword ptr [shade_trunc];

    fld   dword ptr [ ecx ] .rend_dat_tex.dsh1;
    fadd  dword ptr [shade_trunc];

	;
	; sh +trunc
	; dsh1 +trunc

	fxch st(1)
	fsub  dword ptr [shade_trunc];

	;
	; dsh1	+ trunc
	; sh 
	
    fld   dword ptr [ ecx ] .rend_dat_tex.v0;
	
	;
	; dsh1 	+ trunc
	; sh  
	; v0

	fxch st(2)
	fsub  dword ptr [shade_trunc];
	fxch st(2)

    ; dsh1 
	; sh  
	; v0
    fadd  dword ptr [tex_v_magic_alt];  ; offset v0

    ; dsh1 
	; sh  
	; v0 + magic

	fxch st(1)
	fadd  dword ptr [tex_u_magic]
	;
	; dsh1 
    ; v0 + magic
    ; sh + u magic
	;  
	fxch st(2)
	;
	; sh + u magic
	; v0 + magic
    ; dsh1 + du1
	fadd  dword ptr [ ecx ] .rend_dat_tex.du1;
 
	fld   dword ptr [int_to_flt + edi*4]; 
    fmul  dword ptr [ecx ] .rend_dat_tex.dv1
	;
	; sh + u magic
	; v0 + magic
    ; dsh1 + du1
	; vy

    fxch st(3)
    fadd  dword ptr [ ecx ] .rend_dat_tex.u0;

	;
	; vy
    ; v0 + magic
    ; dsh1 + du1
	; sh + u magic + u0
  	
	; find d,dx's
	fld   dword ptr [ ecx ] .rend_dat_tex.dsh0;
    fadd  dword ptr [shade_trunc];
	
	;
	; vy
    ; v0 + magic
    ; dsh1 + du1
	; sh + u magic
  	; dsh0 + trunc

	fxch st(4)

  	; dsh0 + trunc
    ; v0 + magic
    ; dsh1 + du1
	; sh + u magic
	; vy
  	faddp st(3),st ; combine v, and y component

  	; dsh0 + trunc
    ; v0 + magic
    ; dsh1 + du1
	; sh + u magic
	fxch st(1)
 
  	; dsh0 + trunc
    ; v0 + magic
	; sh + u magic
    ; dsh1 + du1
	fst	  qword ptr [shade_u_d_dy];
    fmul  dword ptr [int_to_flt + edi*4] 

	fxch st(3);

    ; (dsh1 + du1)*y
    ; v0 + magic
	; sh + u magic
  	; dsh0 + trunc
	fsub  dword ptr [shade_trunc];


	fld   dword ptr [ ecx ] .rend_dat_tex.dv0;
    fadd  dword ptr [tex_v_magic_alt];

    ; (dsh1 + du1)*y
    ; v0 + magic
	; sh + u magic
  	; dsh0 + trunc
	; dv0
	fxch st(1)


    ; (dsh1 + du1)*y
    ; v0 + magic
	; sh + u magic
	; dv0
  	; dsh0 + trunc
	fadd  dword ptr [ ecx ] .rend_dat_tex.du0;
	
    ; (dsh1 + du1)*y
    ; v0 + magic
	; sh + u magic
	; dv0
  	; dsh0 + trunc
	fxch st (4);

  	; dsh0 + trunc
    ; v0 + magic
	; sh + u magic
	; dv0
    ; (dsh1 + du1)*y
    faddp st(2),st ; combine shade0, and y component

 	; dsh0 + trunc
    ; v0 + magic
	; sh + u magic
	; dv0

	mov [cur_poly], ecx;

	fstp  qword ptr [v_d_dx]; 

 	; dsh0 + trunc
    ; v0 + magic
	; sh + u magic
	fxch st(2)

	; sh + u magic
    ; v0 + magic
 	; dsh0 + trunc
	fst	  qword ptr [shade_u_d_dx]
    fadd  dword ptr [tex_u_magic];

    mov edx,dword ptr [v_d_dx];
    mov esp, fb_starts[ edi*4 ]  ; get start point

    mov edi, [ eax ] ; get x0 
  ; nop

    mov esi, edi;  get x1
    and edi, 1023  ; mask off top

 	fstp  qword ptr [shade_d_dx]; 
	
  
	mov ebx,dword ptr [shade_d_dx]; 
    mov dl, byte  ptr [shade_d_dx+4];
 
	shl ebx, 8;
    mov dh, byte  ptr [shade_d_dx+5];


    mov bl, byte  ptr [v_d_dx+4];
	mov [int_dvsh],edx;

 
    mov [int_duv] ,ebx;
    jmp NEXT_SPAN_SKIP_ST;
	 


;
; edi has cur y
;
   NEXT_SPAN:

    mov esp, fb_starts[ edi*4 ]  ; get start point
    mov edi, [ eax] ; get x0 

    mov esi, edi;  get x1
    and edi, 1023  ; mask off top


   NEXT_SPAN_SKIP_ST:

    fld   qword ptr [ shade_u_d_dx];
    fmul  dword ptr [int_to_flt + edi*4];  
  
    fld  dword ptr [int_to_flt + edi*4];  
    fmul   dword ptr [ecx ].rend_dat_tex.dv0;


	fxch st(1)

   	fadd  st,st(3);  add starting point
    
	fxch st(1)
	
	; stall

   	fadd  st,st(2);  add starting point

    shr esi,9;  
	mov [_cur_span], eax;  save for later

    and esi,1023*2; got x1
	add edi,edi; 

	add esp, esi;  advance to end
  	sub edi, esi;  -dx*2


	fstp  qword ptr [v_cur];


    fstp  qword ptr [shade_cur];


   ; edi  -dx
   ; esp  screen pointer
   ; ebx  temp for tex gen
   ; eax  temp out pixel
   ; ecx   u (high)   v (low)
   ; esi  du (high)  dv (low)
   ; edx   v (high)	  shade (low)
   ; ebp  dv (high)	 dshade (low)

 mov ebx,dword ptr [shade_cur]; 
 mov edx,dword ptr [v_cur];

 shl ebx, 8;
 mov dl, byte  ptr [shade_cur+4];

 mov bl, byte  ptr [v_cur+4];
 mov dh, byte  ptr [shade_cur+5];

 mov ebp, ebx;	copy
 mov esi, [int_duv]

 xor eax, eax;

 mov ecx, [int_dvsh]

 and ebx,  (31 shl (32-5) ) + 31 
MASK_0:


PUT_LOOP:

 rol ebx, 5;
 ROL_BITS_0:
 add edx, ecx; inc color, plus update carry flag for v

 adc ebp, esi ;  increment u,v, bring carry from color
 mov al, dh; get shade

 
 mov ah, 0dadadadah[ebx] ; get texture
TMAP_0:
 mov ebx, ebp;	copy

 shr eax, 2;
 and ebx,  (31 shl (32-5) ) + 31 
MASK_1:


 mov ax, clut[eax*2];
__clut0:

 add edi,2


 mov [esp + edi-2],ax; store into mem
 jl  PUT_LOOP;	still have pixels to draw


 mov eax, [_cur_span]
 mov ecx, [cur_poly]
 
 add eax, 4 ; next data
 mov edx, [_cur_end_span]
 
 cmp edx, eax;
 je  FINISHED;

  ; are we at the end of a block?
  test al, 63
  jz  NEXT_BLOCK;

  BACK_FROM_NEXT_BLOCK:

; find y and delta y
    mov edx, [last_y]
    mov edi, [eax]
    
    inc edx;
    shr edi, 20;

    sub edx,edi
    mov [last_y], edi;

    jne NOT_JUST_ONE;  ; we are on the same line

    ; move down by 1
 
    fadd dword ptr [ecx ] .rend_dat_tex.dv1; 
 	
	fld  qword ptr [ shade_u_d_dy ];
	faddp st(2),st;

    jmp NEXT_SPAN;


	NOT_JUST_ONE:
	
	jl MORE_THAN_ONE;

	jmp NEXT_SPAN;


	MORE_THAN_ONE:
	
	neg edx;
 	
    ; we went down by a couple
	fld   dword ptr [ecx  ] .rend_dat_tex.dv1;
    fmul  dword ptr [int_to_flt + 4 + edx*4]
	
	fld  dword ptr [int_to_flt + 4 + edx*4]
	fmul  qword ptr [  shade_u_d_dy ];
	fxch st(1);
	
	faddp st(2),st
    faddp st(2),st


    jmp NEXT_SPAN;   


    FINISHED:

    
    mov esp, [_esp_save];
    
    fcompp ;  clear fp stack
    
    pop ebx
    pop edi
    pop ebp
    pop esi
 
    ret

    NEXT_BLOCK:

    mov eax, [eax - 64]; get next block
    nop; ; avoid agi

    jmp BACK_FROM_NEXT_BLOCK;



@sb_fill_alt@8 endp



















@sb_fill_alt_tp@8 proc public

   ;  there might be an agi with ecx here

    mov  eax, [ ecx ] .rend_dat_tex.span_buf  
	mov [_cur_end_span], edx;
    
	add  eax, 4;
    push esi

	push ebp
    push edi

    push ebx
 	mov edi, [ eax ];  get y point 

    shr edi, 20     ; extract y
    mov  [_esp_save], esp;
 
    mov [last_y],edi;
   	mov esi, [ecx].rend_dat_tex.tmap;

	mov ebx, [esi].texture.id;


	cmp [cur_tmap_id_alt_tp_sb], ebx;
	je SAME_TEX;

	mov [cur_tmap_id_alt_tp_sb], ebx;
 	
    mov ebx, [esi ].texture.clut
    mov dword ptr [__clut0-4], ebx;

	mov ebx, [esi].texture.map;	 get map part

	; these are all probably misaligned writes..
	mov dword ptr [TMAP_0-4], ebx;

	mov ebx, dword ptr [esi].texture.dim0;
	xor edx, edx;

	mov byte ptr [ ROL_BITS_0 - 1], bl
	
	mov dl,bh;
	and ebx,0000000ffh; 
	
	mov bl, tmap_high_masks[ebx]
	mov bh, tmap_low_masks[edx]

	ror ebx, 8;

	mov dword ptr [MASK_0-4], ebx;
	mov dword ptr [MASK_1-4], ebx;
	mov dword ptr [MASK_2-4], ebx;


	neg dl;
	add dl,127 + 52 - 32;

	shl edx, 23;

    or  edx, (1 shl 22 );

	mov [tex_v_magic_alt_tp] , edx;


    SAME_TEX:

	mov esi, [ ecx ] .rend_dat_tex.sh0;
	mov ebx, [ ecx ] .rend_dat_tex.dsh0;

	mov edx, [ ecx ] .rend_dat_tex.dsh1;
	add esi, (SHADE_BIT_SCALE+8+8) shl 23;

	; scale all shade values
	mov [ ecx ] .rend_dat_tex.sh0,esi;
	add ebx, (SHADE_BIT_SCALE+8+8) shl 23;

	mov [ ecx ] .rend_dat_tex.dsh0,ebx;
	add edx, (SHADE_BIT_SCALE+8+8) shl 23;

	mov [ ecx ] .rend_dat_tex.dsh1,edx;



    fld   dword ptr [ ecx ] .rend_dat_tex.sh0;
    fadd  dword ptr [shade_trunc];

    fld   dword ptr [ ecx ] .rend_dat_tex.dsh1;
    fadd  dword ptr [shade_trunc];

	;
	; sh +trunc
	; dsh1 +trunc

	fxch st(1)
	fsub  dword ptr [shade_trunc];

	;
	; dsh1	+ trunc
	; sh 
	
    fld   dword ptr [ ecx ] .rend_dat_tex.v0;
	
	;
	; dsh1 	+ trunc
	; sh  
	; v0

	fxch st(2)
	fsub  dword ptr [shade_trunc];
	fxch st(2)

    ; dsh1 
	; sh  
	; v0
    fadd  dword ptr [tex_v_magic_alt_tp];  ; offset v0

    ; dsh1 
	; sh  
	; v0 + magic

	fxch st(1)
	fadd  dword ptr [tex_u_magic]
	;
	; dsh1 
    ; v0 + magic
    ; sh + u magic
	;  
	fxch st(2)
	;
	; sh + u magic
	; v0 + magic
    ; dsh1 + du1
	fadd  dword ptr [ ecx ] .rend_dat_tex.du1;
 
	fld   dword ptr [int_to_flt + edi*4]; 
    fmul  dword ptr [ecx ] .rend_dat_tex.dv1
	;
	; sh + u magic
	; v0 + magic
    ; dsh1 + du1
	; vy

    fxch st(3)
    fadd  dword ptr [ ecx ] .rend_dat_tex.u0;

	;
	; vy
    ; v0 + magic
    ; dsh1 + du1
	; sh + u magic + u0
  	
	; find d,dx's
	fld   dword ptr [ ecx ] .rend_dat_tex.dsh0;
    fadd  dword ptr [shade_trunc];
	
	;
	; vy
    ; v0 + magic
    ; dsh1 + du1
	; sh + u magic
  	; dsh0 + trunc

	fxch st(4)

  	; dsh0 + trunc
    ; v0 + magic
    ; dsh1 + du1
	; sh + u magic
	; vy
  	faddp st(3),st ; combine v, and y component

  	; dsh0 + trunc
    ; v0 + magic
    ; dsh1 + du1
	; sh + u magic
	fxch st(1)
 
  	; dsh0 + trunc
    ; v0 + magic
	; sh + u magic
    ; dsh1 + du1
	fst	  qword ptr [shade_u_d_dy];
    fmul  dword ptr [int_to_flt + edi*4] 

	fxch st(3);

    ; (dsh1 + du1)*y
    ; v0 + magic
	; sh + u magic
  	; dsh0 + trunc
	fsub  dword ptr [shade_trunc];


	fld   dword ptr [ ecx ] .rend_dat_tex.dv0;
    fadd  dword ptr [tex_v_magic_alt_tp];

    ; (dsh1 + du1)*y
    ; v0 + magic
	; sh + u magic
  	; dsh0 + trunc
	; dv0
	fxch st(1)


    ; (dsh1 + du1)*y
    ; v0 + magic
	; sh + u magic
	; dv0
  	; dsh0 + trunc
	fadd  dword ptr [ ecx ] .rend_dat_tex.du0;
	
    ; (dsh1 + du1)*y
    ; v0 + magic
	; sh + u magic
	; dv0
  	; dsh0 + trunc
	fxch st (4);

  	; dsh0 + trunc
    ; v0 + magic
	; sh + u magic
	; dv0
    ; (dsh1 + du1)*y
    faddp st(2),st ; combine shade0, and y component

 	; dsh0 + trunc
    ; v0 + magic
	; sh + u magic
	; dv0

	mov [cur_poly], ecx;

	fstp  qword ptr [v_d_dx]; 

 	; dsh0 + trunc
    ; v0 + magic
	; sh + u magic
	fxch st(2)

	; sh + u magic
    ; v0 + magic
 	; dsh0 + trunc
	fst	  qword ptr [shade_u_d_dx]
    fadd  dword ptr [tex_u_magic];

    mov edx,dword ptr [v_d_dx];
    mov esp, fb_starts[ edi*4 ]  ; get start point

    mov edi, [ eax ] ; get x0 
  ; nop

    mov esi, edi;  get x1
    and edi, 1023  ; mask off top

 	fstp  qword ptr [shade_d_dx]; 
	
  
	mov ebx,dword ptr [shade_d_dx]; 
    mov dl, byte  ptr [shade_d_dx+4];
 
	shl ebx, 8;
    mov dh, byte  ptr [shade_d_dx+5];


    mov bl, byte  ptr [v_d_dx+4];
	mov [int_dvsh],edx;

 
    mov [int_duv] ,ebx;
    jmp NEXT_SPAN_SKIP_ST;
	 


;
; edi has cur y
;
   NEXT_SPAN:

    mov esp, fb_starts[ edi*4 ]  ; get start point
    mov edi, [ eax] ; get x0 

    mov esi, edi;  get x1
    and edi, 1023  ; mask off top


   NEXT_SPAN_SKIP_ST:

    fld   qword ptr [ shade_u_d_dx];
    fmul  dword ptr [int_to_flt + edi*4];  
  
    fld  dword ptr [int_to_flt + edi*4];  
    fmul   dword ptr [ecx ].rend_dat_tex.dv0;


	fxch st(1)

   	fadd  st,st(3);  add starting point
    
	fxch st(1)
	
	; stall

   	fadd  st,st(2);  add starting point

    shr esi,9;  
	mov [_cur_span], eax;  save for later

    and esi,1023*2; got x1
	add edi,edi; 

	add esp, esi;  advance to end
  	sub edi, esi;  -dx*2


	fstp  qword ptr [v_cur];


    fstp  qword ptr [shade_cur];


   ; edi  -dx
   ; esp  screen pointer
   ; ebx  temp for tex gen
   ; eax  temp out pixel
   ; ecx   u (high)   v (low)
   ; esi  du (high)  dv (low)
   ; edx   v (high)	  shade (low)
   ; ebp  dv (high)	 dshade (low)

 mov ebx,dword ptr [shade_cur]; 
 mov edx,dword ptr [v_cur];

 shl ebx, 8;
 mov dl, byte  ptr [shade_cur+4];

 mov bl, byte  ptr [v_cur+4];
 mov dh, byte  ptr [shade_cur+5];

 mov ebp, ebx;	copy
 mov esi, [int_duv]

 xor eax, eax;

 mov ecx, [int_dvsh]

 and ebx,  (31 shl (32-5) ) + 31 
MASK_0:


PUT_LOOP:

 rol ebx, 5;
 ROL_BITS_0:
 add edx, ecx; inc color, plus update carry flag for v

 adc ebp, esi ;  increment u,v, bring carry from color
 mov al, dh; get shade

 
 mov ah, 0dadadadah[ebx] ; get texture
TMAP_0:
 mov ebx, ebp;	copy

 
 cmp ah, 0;
fill_alt_tp_index::
public C 	fill_alt_tp_index;
 je  dont_put;




 shr eax, 2;
 and ebx,  (31 shl (32-5) ) + 31 
MASK_1:


 mov ax, clut[eax*2];
__clut0:

 add edi,2


 mov [esp + edi-2],ax; store into mem
 jl  PUT_LOOP;	still have pixels to draw


 dont_put:

 and ebx,  (31 shl (32-5) ) + 31 
MASK_2:

 add edi,2
 jl  PUT_LOOP;	still have pixels to draw




 mov eax, [_cur_span]
 mov ecx, [cur_poly]
 
 add eax, 4 ; next data
 mov edx, [_cur_end_span]
 
 cmp edx, eax;
 je  FINISHED;

  ; are we at the end of a block?
  test al, 63
  jz  NEXT_BLOCK;

  BACK_FROM_NEXT_BLOCK:

; find y and delta y
    mov edx, [last_y]
    mov edi, [eax]
    
    inc edx;
    shr edi, 20;

    sub edx,edi
    mov [last_y], edi;

    jne NOT_JUST_ONE;  ; we are on the same line

    ; move down by 1
 
    fadd dword ptr [ecx ] .rend_dat_tex.dv1; 
 	
	fld  qword ptr [ shade_u_d_dy ];
	faddp st(2),st;

    jmp NEXT_SPAN;


	NOT_JUST_ONE:
	
	jl MORE_THAN_ONE;

	jmp NEXT_SPAN;


	MORE_THAN_ONE:
	
	neg edx;
 	
    ; we went down by a couple
	fld   dword ptr [ecx  ] .rend_dat_tex.dv1;
    fmul  dword ptr [int_to_flt + 4 + edx*4]
	
	fld  dword ptr [int_to_flt + 4 + edx*4]
	fmul  qword ptr [  shade_u_d_dy ];
	fxch st(1);
	
	faddp st(2),st
    faddp st(2),st


    jmp NEXT_SPAN;   


    FINISHED:

    
    mov esp, [_esp_save];
    
    fcompp ;  clear fp stack
    
    pop ebx
    pop edi
    pop ebp
    pop esi
 
    ret

    NEXT_BLOCK:

    mov eax, [eax - 64]; get next block
    nop; ; avoid agi

    jmp BACK_FROM_NEXT_BLOCK;



@sb_fill_alt_tp@8 endp









;DIV_BITS equ 3
;DIV_LG   equ (1 shl DIV_BITS)
;V_BITS equ 5

;rend_dat_p_tex	struct
;
;  z0  dword ?;
;  dz0 dword ?;
;  dz1 dword ?;
;
;  span_buf dword ?;
;
;  tmap dword ?;  also color
;
;  u0 dword ?;
;  du0 dword ?;
;  du1 dword ?;
;
;  v0 dword ?;
;  dv0 dword ?;
;  dv1 dword ?;
;
;
;rend_dat_p_tex ends
























;
;
; fill g3
;

	   
rend_dat_g3 	struct

  z0  dword ?;
  dz0 dword ?;
  dz1 dword ?;

  span_buf dword ?;

  r0  dword  ?;
  dred0 dword ?;
  dred1 dword ?;

  g0 dword ?;
  dg0 dword ?;
  dg1 dword ?;

  b0 dword ?;
  db0 dword ?;
  db1 dword ?;


rend_dat_g3 ends























rend_dat_gour struct

  z0  dword ?;
  dz0 dword ?;
  dz1 dword ?;

  span_buf dword ?;
 
  color  dword ?;  
 
  sh0 dword ?;
  dsh0 dword ?;
  dsh1 dword ?;

rend_dat_gour ends




@sb_fill_als@8 proc public

RD_REG   equ esi
SPAN_REG equ eax

    push esi
    push ebp

	mov esi,  ecx;
    mov eax, [ ecx ] .rend_dat_gour.span_buf  

    push edi

    add SPAN_REG, 4; skip to first span
	; overwrite
	mov  [ RD_REG ] .rend_dat_gour.span_buf, edx;

    push ebx
    mov  [_esp_save], esp;
    
    mov edi, [ SPAN_REG ] 

    shr edi, 20;

    mov [last_y],edi;

    fld   dword ptr [int_to_flt + edi*4]; 
    fmul dword ptr [RD_REG ] .rend_dat_gour.dsh1
   


    mov ecx, [ RD_REG ].rend_dat_gour.color
	shr ecx, 1;
	mov byte ptr   [shade_magic+5], cl


    fld   dword ptr [ RD_REG ] .rend_dat_gour.sh0;
    fadd  qword ptr [shade_magic];

; undo offset 
	mov byte ptr  [shade_magic+5], 0


    fld   dword ptr [RD_REG ] .rend_dat_gour.dsh0; ; get shade dx
    fadd  qword ptr [shade_magic];        ; offset
 
    fxch st(1)     ; get y start
    
    faddp st(2),st ; combine shade0, and y component

    fstp qword ptr [misc_qw_store]; 
    mov  ebp, dword ptr [misc_qw_store + 4]; 
   
   ; xor ecx, ecx;

    mov ecx, [ RD_REG ].rend_dat_gour.color

	shr ecx, 1
;	shr ch, 8-ut_shade_bits;
	jmp NEXT_SPAN;




 JUST_ONE_PIX:
 
 fstp  qword ptr [misc_qw_store];
 mov  cl,  byte ptr [misc_qw_store+5];
 
 jmp LAST_PUT;



   NEXT_SPAN:

    ; get start
    mov esp, fb_starts[ edi*4 ];  ; get start point
    mov ebx, [SPAN_REG ] 

    mov edi, ebx;
    and ebx, 1023;   ; mask off top
  
    fld    dword ptr [RD_REG ].rend_dat_gour.dsh0;
    fmul   dword ptr [int_to_flt + ebx*4];  

    shr edi,10; ; want x1 
	lea esp, [esp + ebx*2];       ; get start pt

    and edi,1023;
 
    fadd  st,st(1);  ; add starting point
   
    sub edi,ebx;     ; get dx
	; nop
	
	dec edi;
	jz JUST_ONE_PIX
 
	shr bl, 1; check for odd

    fstp  qword ptr [misc_qw_store];
    
	mov ebx,  dword ptr [misc_qw_store+4];
	jnc PUT_DWORD_START;

  PUT_WORD:

    mov cl, bh;  copy shade
    add ebx, ebp; update

    mov dx, word ptr [ ecx*2 ]; ;  get pixel
__clut1:
    add esp, 2;

    mov word ptr [esp-2], dx;  ; store pixel
    dec edi;

 	mov cl, bh;  copy shade
    je LAST_PUT;
 

 PUT_DWORD_START:
    mov cl, bh;
    add ebx, ebp; update


 PUT_DWORD:
   
    mov dx, word ptr [ ecx*2 ] ;  get pixel
__clut2:
    mov cl, bh;  copy shade

    shl edx, 16;
    add ebx, ebp; update

    mov dx, word ptr [ ecx*2 ] ;  get pixel
__clut3:
    mov cl, bh;  copy shade

    rol edx, 16;
    add ebx, ebp; update
    
    mov dword ptr [esp], edx;  ; store pixel
    add esp, 4;

    sub edi, 2
  jg PUT_DWORD;

  jl TEST_NEXT_SPAN;
 

 LAST_PUT:

    mov dx, word ptr [ ecx*2 ]; ;  get pixel
__clut4::
    mov word ptr [esp], dx;  ; store pixel


    TEST_NEXT_SPAN:
  

    mov edx, [RD_REG] .rend_dat_gour.span_buf
    add SPAN_REG, 4; ; next data

    cmp edx, SPAN_REG;
    je  FINISHED;

    ; are we at the end of a block?
    test al, 63
    jz  NEXT_BLOCK;

    BACK_FROM_NEXT_BLOCK:


    mov edx, [last_y]
    mov edi, [SPAN_REG]
    
    inc edx;
    shr edi, 20;

    sub edx, edi
    mov [last_y], edi;

    jg  NEXT_SPAN;  ; we are on the same line

    ; move down by 1
    fadd dword ptr [RD_REG ] .rend_dat_gour.dsh1; 
	neg edx
    je NEXT_SPAN;   ; we only went down by 1

    ; we went down by a couple
    fld   dword ptr [int_to_flt + edx*4]
    fmul  dword ptr [RD_REG  ] .rend_dat_gour.dsh1;
    faddp st(1),st

    jmp NEXT_SPAN;   


    FINISHED:

    
    mov esp, [_esp_save];
    
    fcomp st(0);  clear fp stack
    
    pop ebx
    pop edi
    pop ebp
    pop esi
 
    ret

    NEXT_BLOCK:

    mov SPAN_REG, [SPAN_REG - 64]; get next block
    nop; ; avoid agi

    jmp BACK_FROM_NEXT_BLOCK;

	   





@sb_fill_als@8 endp










rend_dat_flat struct

  z0  dword ?;
  dz0 dword ?;
  dz1 dword ?;

  span_buf dword ?;
 
  color  dword ?; 

rend_dat_flat ends





@sb_fill_afs@8 proc public


    mov eax, [ ecx ] .rend_dat_flat.span_buf  
    push esi

    add eax, 4; skip to first span
	mov esi,  ecx;

    push ebp
    push edi

    mov ebp, [ eax ] 
    push ebx

    mov  [_esp_save], esp;
    
    shr ebp, 20;
	mov ecx,  [ esi ] .rend_dat_flat.color;

 
   NEXT_SPAN:


    ; get start
    mov esp, fb_starts[ ebp*4 ];  ; get start point
    mov ebx, [eax ] ; get x0,x1 

    mov edi, ebx;
	and ebx, 1023 shl 10; mask off x1
 
    shr ebx, 10;  x1 
    and edi, 1023;x0  
  
	sub edi,ebx     ; get -dx
	nop

	lea esp,[esp+ebx*2-2];    get end pt
 	mov bl, [eax];	get x0 again

 	inc edi;
	jz LAST_PUT
 
	shr bl, 1; check for odd
	jnc PUT_DWORD;

  PUT_WORD:


    mov word ptr [esp + edi*2], cx;  ; store pixel
    inc edi;
 
    jz LAST_PUT;
 

 PUT_DWORD:
   
    mov dword ptr [esp+edi*2], ecx;  ; store pixel
    add edi, 2

  jl PUT_DWORD;


  jg TEST_NEXT_SPAN;
 

 LAST_PUT:

    mov word ptr [esp+edi*2], cx;  ; store pixel


    TEST_NEXT_SPAN:
  
    add eax, 4; ; next data

    cmp edx, eax;
    je  FINISHED;

    ; are we at the end of a block?
    test al, 63
    jz  NEXT_BLOCK;

    BACK_FROM_NEXT_BLOCK:

    mov ebp, [eax]
  
    shr ebp, 20;
    jmp NEXT_SPAN;   


    FINISHED:

    
    mov esp, [_esp_save];
    
    
    pop ebx
    pop edi
    pop ebp
    pop esi
 
    ret

    NEXT_BLOCK:

    mov eax, [eax - 64]; get next block
    nop; ; avoid agi

    jmp BACK_FROM_NEXT_BLOCK;

	   


@sb_fill_afs@8 endp





				 





























draw_sb_asm_end_0:
public C draw_sb_asm_end_0;



end















@sb_fill_als@8 proc public

RD_REG   equ esi
SPAN_REG equ eax

    push esi
    push ebp

	mov esi,  ecx;
    mov eax, [ ecx ] .rend_dat_gour.span_buf  

    push edi

    add SPAN_REG, 4; skip to first span
	; overwrite
	mov  [ RD_REG ] .rend_dat_gour.span_buf, edx;

    push ebx
    mov  [_esp_save], esp;
    
    mov edi, [ SPAN_REG ] 

    shr edi, 20;

    mov [last_y],edi;

    fld   dword ptr [int_to_flt + edi*4]; 
    fmul dword ptr [RD_REG ] .rend_dat_gour.dsh1
   

    mov ch, byte ptr  [ RD_REG ].rend_dat_gour.color
	shl ch, ut_shade_bits;
	mov byte ptr   [shade_magic+5], ch

    fld   dword ptr [ RD_REG ] .rend_dat_gour.sh0;
    fadd  qword ptr [shade_magic];

	mov byte ptr  [shade_magic+5], 0

    fld   dword ptr [RD_REG ] .rend_dat_gour.dsh0; ; get shade dx
    fadd  qword ptr [shade_magic];        ; offset
 
    fxch st(1)     ; get y start
    
    faddp st(2),st ; combine shade0, and y component

    fstp qword ptr [misc_qw_store]; 
    mov  ebp, dword ptr [misc_qw_store + 4]; 
   
    xor ecx, ecx;

    mov ch, byte ptr  [ RD_REG ].rend_dat_gour.color

	shr ch, 8-ut_shade_bits;
	jmp NEXT_SPAN;




 JUST_ONE_PIX:
 
 fstp  qword ptr [misc_qw_store];
 mov  cl,  byte ptr [misc_qw_store+5];
 
 jmp LAST_PUT;



   NEXT_SPAN:

    ; get start
    mov esp, fb_starts[ edi*4 ];  ; get start point
    mov ebx, [SPAN_REG ] 

    mov edi, ebx;
    and ebx, 1023;   ; mask off top
  
    fld    dword ptr [RD_REG ].rend_dat_gour.dsh0;
    fmul   dword ptr [int_to_flt + ebx*4];  

    shr edi,10; ; want x1 
	lea esp, [esp + ebx*2];       ; get start pt

    and edi,1023;
 
    fadd  st,st(1);  ; add starting point
   
    sub edi,ebx;     ; get dx
	; nop
	
	dec edi;
	jz JUST_ONE_PIX
 
	shr bl, 1; check for odd

    fstp  qword ptr [misc_qw_store];
    
	mov ebx,  dword ptr [misc_qw_store+4];
	jnc PUT_DWORD_START;

  PUT_WORD:

    mov cl, bh;  copy shade
    add ebx, ebp; update

    mov dx, word ptr clut[ ecx*2 ]; ;  get pixel
__clut1::
    add esp, 2;

    mov word ptr [esp-2], dx;  ; store pixel
    dec edi;

 	mov cl, bh;  copy shade
    je LAST_PUT;
 

 PUT_DWORD_START:
    mov cl, bh;
    add ebx, ebp; update


 PUT_DWORD:
   
    mov dx, word ptr clut[ ecx*2 ] ;  get pixel
__clut2::
    mov cl, bh;  copy shade

    shl edx, 16;
    add ebx, ebp; update

    mov dx, word ptr clut[ ecx*2 ] ;  get pixel
__clut3::
    mov cl, bh;  copy shade

    rol edx, 16;
    add ebx, ebp; update
    
    mov dword ptr [esp], edx;  ; store pixel
    add esp, 4;

    sub edi, 2
  jg PUT_DWORD;

  jl TEST_NEXT_SPAN;
 

 LAST_PUT:

    mov dx, word ptr clut[ ecx*2 ]; ;  get pixel
__clut4::
    mov word ptr [esp], dx;  ; store pixel


    TEST_NEXT_SPAN:
  

    mov edx, [RD_REG] .rend_dat_gour.span_buf
    add SPAN_REG, 4; ; next data

    cmp edx, SPAN_REG;
    je  FINISHED;

    ; are we at the end of a block?
    test al, 63
    jz  NEXT_BLOCK;

    BACK_FROM_NEXT_BLOCK:


    mov edx, [last_y]
    mov edi, [SPAN_REG]
    
    inc edx;
    shr edi, 20;

    sub edx, edi
    mov [last_y], edi;

    jg  NEXT_SPAN;  ; we are on the same line

    ; move down by 1
    fadd dword ptr [RD_REG ] .rend_dat_gour.dsh1; 
	neg edx
    je NEXT_SPAN;   ; we only went down by 1

    ; we went down by a couple
    fld   dword ptr [int_to_flt + edx*4]
    fmul  dword ptr [RD_REG  ] .rend_dat_gour.dsh1;
    faddp st(1),st

    jmp NEXT_SPAN;   


    FINISHED:

    
    mov esp, [_esp_save];
    
    fcomp st(0);  clear fp stack
    
    pop ebx
    pop edi
    pop ebp
    pop esi
 
    ret

    NEXT_BLOCK:

    mov SPAN_REG, [SPAN_REG - 64]; get next block
    nop; ; avoid agi

    jmp BACK_FROM_NEXT_BLOCK;

	   





@sb_fill_als@8 endp




